// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Descriptor.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceGrid;

/**
 * An application update descriptor to describe the updates to apply
 * to a deployed application.
 * 
 **/
public class ApplicationUpdateDescriptor implements java.lang.Cloneable, java.io.Serializable
{
    /**
     * The name of the application to update.
     * 
     **/
    public String name;

    /**
     * The updated description (or null if the description wasn't
     * updated.)
     * 
     **/
    public BoxedString description;

    /**
     * The updated distribution application descriptor.
     * 
     **/
    public BoxedDistributionDescriptor distrib;

    /**
     * The variables to update.
     * 
     **/
    public java.util.Map<java.lang.String, java.lang.String> variables;

    /**
     * The variables to remove.
     * 
     **/
    public String[] removeVariables;

    /**
     * The property sets to update.
     * 
     **/
    public java.util.Map<java.lang.String, PropertySetDescriptor> propertySets;

    /**
     * The property sets to remove.
     * 
     **/
    public String[] removePropertySets;

    /**
     * The replica groups to update.
     * 
     **/
    public java.util.List<ReplicaGroupDescriptor> replicaGroups;

    /**
     * The replica groups to remove.
     * 
     **/
    public String[] removeReplicaGroups;

    /**
     * The server templates to update.
     * 
     **/
    public java.util.Map<java.lang.String, TemplateDescriptor> serverTemplates;

    /**
     * The ids of the server template to remove.
     * 
     **/
    public String[] removeServerTemplates;

    /**
     * The service templates to update.
     * 
     **/
    public java.util.Map<java.lang.String, TemplateDescriptor> serviceTemplates;

    /**
     * The ids of the service template to remove.
     * 
     **/
    public String[] removeServiceTemplates;

    /**
     * The application nodes to update.
     * 
     **/
    public java.util.List<NodeUpdateDescriptor> nodes;

    /**
     * The nodes to remove.
     * 
     **/
    public String[] removeNodes;

    public ApplicationUpdateDescriptor()
    {
    }

    public ApplicationUpdateDescriptor(String name, BoxedString description, BoxedDistributionDescriptor distrib, java.util.Map<java.lang.String, java.lang.String> variables, String[] removeVariables, java.util.Map<java.lang.String, PropertySetDescriptor> propertySets, String[] removePropertySets, java.util.List<ReplicaGroupDescriptor> replicaGroups, String[] removeReplicaGroups, java.util.Map<java.lang.String, TemplateDescriptor> serverTemplates, String[] removeServerTemplates, java.util.Map<java.lang.String, TemplateDescriptor> serviceTemplates, String[] removeServiceTemplates, java.util.List<NodeUpdateDescriptor> nodes, String[] removeNodes)
    {
        this.name = name;
        this.description = description;
        this.distrib = distrib;
        this.variables = variables;
        this.removeVariables = removeVariables;
        this.propertySets = propertySets;
        this.removePropertySets = removePropertySets;
        this.replicaGroups = replicaGroups;
        this.removeReplicaGroups = removeReplicaGroups;
        this.serverTemplates = serverTemplates;
        this.removeServerTemplates = removeServerTemplates;
        this.serviceTemplates = serviceTemplates;
        this.removeServiceTemplates = removeServiceTemplates;
        this.nodes = nodes;
        this.removeNodes = removeNodes;
    }

    public boolean
    equals(java.lang.Object rhs)
    {
        if(this == rhs)
        {
            return true;
        }
        ApplicationUpdateDescriptor _r = null;
        if(rhs instanceof ApplicationUpdateDescriptor)
        {
            _r = (ApplicationUpdateDescriptor)rhs;
        }

        if(_r != null)
        {
            if(name != _r.name)
            {
                if(name == null || _r.name == null || !name.equals(_r.name))
                {
                    return false;
                }
            }
            if(description != _r.description)
            {
                if(description == null || _r.description == null || !description.equals(_r.description))
                {
                    return false;
                }
            }
            if(distrib != _r.distrib)
            {
                if(distrib == null || _r.distrib == null || !distrib.equals(_r.distrib))
                {
                    return false;
                }
            }
            if(variables != _r.variables)
            {
                if(variables == null || _r.variables == null || !variables.equals(_r.variables))
                {
                    return false;
                }
            }
            if(!java.util.Arrays.equals(removeVariables, _r.removeVariables))
            {
                return false;
            }
            if(propertySets != _r.propertySets)
            {
                if(propertySets == null || _r.propertySets == null || !propertySets.equals(_r.propertySets))
                {
                    return false;
                }
            }
            if(!java.util.Arrays.equals(removePropertySets, _r.removePropertySets))
            {
                return false;
            }
            if(replicaGroups != _r.replicaGroups)
            {
                if(replicaGroups == null || _r.replicaGroups == null || !replicaGroups.equals(_r.replicaGroups))
                {
                    return false;
                }
            }
            if(!java.util.Arrays.equals(removeReplicaGroups, _r.removeReplicaGroups))
            {
                return false;
            }
            if(serverTemplates != _r.serverTemplates)
            {
                if(serverTemplates == null || _r.serverTemplates == null || !serverTemplates.equals(_r.serverTemplates))
                {
                    return false;
                }
            }
            if(!java.util.Arrays.equals(removeServerTemplates, _r.removeServerTemplates))
            {
                return false;
            }
            if(serviceTemplates != _r.serviceTemplates)
            {
                if(serviceTemplates == null || _r.serviceTemplates == null || !serviceTemplates.equals(_r.serviceTemplates))
                {
                    return false;
                }
            }
            if(!java.util.Arrays.equals(removeServiceTemplates, _r.removeServiceTemplates))
            {
                return false;
            }
            if(nodes != _r.nodes)
            {
                if(nodes == null || _r.nodes == null || !nodes.equals(_r.nodes))
                {
                    return false;
                }
            }
            if(!java.util.Arrays.equals(removeNodes, _r.removeNodes))
            {
                return false;
            }

            return true;
        }

        return false;
    }

    public int
    hashCode()
    {
        int __h = 5381;
        __h = IceInternal.HashUtil.hashAdd(__h, "::IceGrid::ApplicationUpdateDescriptor");
        __h = IceInternal.HashUtil.hashAdd(__h, name);
        __h = IceInternal.HashUtil.hashAdd(__h, description);
        __h = IceInternal.HashUtil.hashAdd(__h, distrib);
        __h = IceInternal.HashUtil.hashAdd(__h, variables);
        __h = IceInternal.HashUtil.hashAdd(__h, removeVariables);
        __h = IceInternal.HashUtil.hashAdd(__h, propertySets);
        __h = IceInternal.HashUtil.hashAdd(__h, removePropertySets);
        __h = IceInternal.HashUtil.hashAdd(__h, replicaGroups);
        __h = IceInternal.HashUtil.hashAdd(__h, removeReplicaGroups);
        __h = IceInternal.HashUtil.hashAdd(__h, serverTemplates);
        __h = IceInternal.HashUtil.hashAdd(__h, removeServerTemplates);
        __h = IceInternal.HashUtil.hashAdd(__h, serviceTemplates);
        __h = IceInternal.HashUtil.hashAdd(__h, removeServiceTemplates);
        __h = IceInternal.HashUtil.hashAdd(__h, nodes);
        __h = IceInternal.HashUtil.hashAdd(__h, removeNodes);
        return __h;
    }

    public java.lang.Object
    clone()
    {
        java.lang.Object o = null;
        try
        {
            o = super.clone();
        }
        catch(CloneNotSupportedException ex)
        {
            assert false; // impossible
        }
        return o;
    }

    public void
    __write(IceInternal.BasicStream __os)
    {
        __os.writeString(name);
        __os.writeObject(description);
        __os.writeObject(distrib);
        StringStringDictHelper.write(__os, variables);
        Ice.StringSeqHelper.write(__os, removeVariables);
        PropertySetDescriptorDictHelper.write(__os, propertySets);
        Ice.StringSeqHelper.write(__os, removePropertySets);
        ReplicaGroupDescriptorSeqHelper.write(__os, replicaGroups);
        Ice.StringSeqHelper.write(__os, removeReplicaGroups);
        TemplateDescriptorDictHelper.write(__os, serverTemplates);
        Ice.StringSeqHelper.write(__os, removeServerTemplates);
        TemplateDescriptorDictHelper.write(__os, serviceTemplates);
        Ice.StringSeqHelper.write(__os, removeServiceTemplates);
        NodeUpdateDescriptorSeqHelper.write(__os, nodes);
        Ice.StringSeqHelper.write(__os, removeNodes);
    }

    private class Patcher implements IceInternal.Patcher
    {
        Patcher(int member)
        {
            __member = member;
        }

        public void
        patch(Ice.Object v)
        {
            switch(__member)
            {
            case 0:
                __typeId = "::IceGrid::BoxedString";
                if(v == null || v instanceof BoxedString)
                {
                    description = (BoxedString)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 1:
                __typeId = "::IceGrid::BoxedDistributionDescriptor";
                if(v == null || v instanceof BoxedDistributionDescriptor)
                {
                    distrib = (BoxedDistributionDescriptor)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            }
        }

        public String
        type()
        {
            return __typeId;
        }

        private int __member;
        private String __typeId;
    }

    public void
    __read(IceInternal.BasicStream __is)
    {
        name = __is.readString();
        __is.readObject(new Patcher(0));
        __is.readObject(new Patcher(1));
        variables = new java.util.TreeMap<String, String>();
        int __sz0 = __is.readSize();
        for(int __i0 = 0; __i0 < __sz0; __i0++)
        {
            String __key;
            __key = __is.readString();
            String __value;
            __value = __is.readString();
            variables.put(__key, __value);
        }
        removeVariables = Ice.StringSeqHelper.read(__is);
        propertySets = PropertySetDescriptorDictHelper.read(__is);
        removePropertySets = Ice.StringSeqHelper.read(__is);
        replicaGroups = ReplicaGroupDescriptorSeqHelper.read(__is);
        removeReplicaGroups = Ice.StringSeqHelper.read(__is);
        serverTemplates = TemplateDescriptorDictHelper.read(__is);
        removeServerTemplates = Ice.StringSeqHelper.read(__is);
        serviceTemplates = TemplateDescriptorDictHelper.read(__is);
        removeServiceTemplates = Ice.StringSeqHelper.read(__is);
        nodes = NodeUpdateDescriptorSeqHelper.read(__is);
        removeNodes = Ice.StringSeqHelper.read(__is);
    }

    public static final long serialVersionUID = 317496849L;
}
